Ruby: pm_class_node Struct Reference

Ruby 3.4.6p54 (2025-09-16 revision dbd83256b1cec76c69756ecb8758b9e1079833de)

Data Fields
pm_class_node Struct Reference

ClassNode. More...

`#include <ast.h>`

## Data Fields
pm_node_t | base
| The embedded base node.
pm_constant_id_list_t | locals
| ClassNode#locals.
pm_location_t | class_keyword_loc
| ClassNode#class_keyword_loc.
struct pm_node * | constant_path
| ClassNode#constant_path.
pm_location_t | inheritance_operator_loc
| ClassNode#inheritance_operator_loc.
struct pm_node * | superclass
| ClassNode#superclass.
struct pm_node * | body
| ClassNode#body.
pm_location_t | end_keyword_loc
| ClassNode#end_keyword_loc.
pm_constant_id_t | name
| ClassNode#name.
Data Fields inherited from pm_node
pm_node_type_t | type
| This represents the type of the node.
pm_node_flags_t | flags
| This represents any flags on the node.
uint32_t | node_id
| The unique identifier for this node, which is deterministic based on the source.
pm_location_t | location
| This is the location of the node in the source.

## Detailed Description

ClassNode.

Represents a class declaration involving the class keyword.

    class Foo end
    ^^^^^^^^^^^^^

Type: ::PM_CLASS_NODE

Definition at line 2693 of file ast.h.

## Field Documentation

## ◆ base

pm_node_t pm_class_node::base

The embedded base node.

Definition at line 2695 of file ast.h.

Referenced by pm_dump_json().

## ◆ body

struct pm_node* pm_class_node::body

ClassNode#body.

Represents the body of the class.

    class Foo
      foo
      ^^^

Definition at line 2747 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

## ◆ class_keyword_loc

pm_location_t pm_class_node::class_keyword_loc

ClassNode#class_keyword_loc.

Represents the location of the class keyword.

    class Foo end
    ^^^^^

Definition at line 2711 of file ast.h.

Referenced by pm_dump_json().

## ◆ constant_path

struct pm_node* pm_class_node::constant_path

ClassNode#constant_path.

Definition at line 2716 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

## ◆ end_keyword_loc

pm_location_t pm_class_node::end_keyword_loc

ClassNode#end_keyword_loc.

Represents the location of the end keyword.

    class Foo end
              ^^^

Definition at line 2757 of file ast.h.

Referenced by pm_dump_json().

## ◆ inheritance_operator_loc

pm_location_t pm_class_node::inheritance_operator_loc

ClassNode#inheritance_operator_loc.

Represents the location of the < operator.

    class Foo < Bar
              ^

Definition at line 2726 of file ast.h.

Referenced by pm_dump_json().

## ◆ locals

pm_constant_id_list_t pm_class_node::locals

ClassNode#locals.

Definition at line 2701 of file ast.h.

Referenced by pm_dump_json(), and pm_node_destroy().

## ◆ name

pm_constant_id_t pm_class_node::name

ClassNode#name.

The name of the class.

    class Foo end # name `:Foo`

Definition at line 2766 of file ast.h.

Referenced by pm_dump_json().

## ◆ superclass

struct pm_node* pm_class_node::superclass

ClassNode#superclass.

Represents the superclass of the class.

    class Foo < Bar
                ^^^

Definition at line 2736 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

The documentation for this struct was generated from the following file:

- prism/ast.h